{***************************************************************************}
{*                              SWEXPR.PAS                                 *}
{*                  SoftWeyr Expression Interpreter                        *}
{*                              Version 1.0                                *}
{*               Copyright (c) by SoftWeyr,1994                            *}
{***************************************************************************}




{騥 :
   ᮤন ।⢠  樨 䬥᪨ ࠦ
 (⨯ Real) ।   ப ६. ࠦ 
 ᮤঠ:
 1. ⢥ ⠭  ଠ, ਭ⮬  몥 Pascal
 2. 樨 * / + - (᫥  ⥯ ॠ  ⠭⭠ 㭪)
 3. 㭪樨  ⠭, ⠪  । 짮⥫, 騥
     MaxStackDepth ࠬ஢
 4. । 짮⥫ ६ (⮣ 짮⥫ ਤ
    ᠬ , ⮡  뫮 ᢮ 祭,   
     ࠭)
 5. 㣫 ᪮   ⢥.
 樨  Pascal ᨨ 6.0   ⢮ 㭪権  ६
 ࠭祭 16384,  ᨨ 5.x - 祭ﬨ ⠭ MaxFuncCount 
 MaxVarCount. ࠦ ᭠砫   ७ ᥢ,
  ⥬ 㦥   (, -   
 筮 )}

{$IFDEF Ver55}
 {$DEFINE OldVersion}
{$ENDIF}
{$IFDEF Ver50}
 {$DEFINE OldVersion}
{$ENDIF}
Unit SWExpr;
interface
{$IFNDEF OldVersion}
uses objects;
{$ENDIF}
 Const MaxStackDepth=32;
 {$IFDEF OldVersion}
	   MaxFuncCount=32;
	   MaxVarCount=32;
 {$ENDIF}
Type
	 ErrorMessageType = (erNoError,erInvalidSymbol,erUndeclaredVar,
                             erUndeclaredFunc,erExpectedSymbol,erExtraCharacters,
                             erInvalidNumber,erDivideByZero,erInvalidArgument);
	 PFunction = ^TFunction;
	 TFunction = record
					Name:String[8];
					Code:Pointer;{⥫  楤}
					ParamCount:Integer;
				  end;
        PVariable = ^TVariable;
	TVariable = record
				  Name:String[8];
				  Code:LongInt;
				end;
	TCalcFunc=Procedure;{ 楤, 饩 짮⥫ 㭪}
	 { 楤 믮 ᫥ ᫥⥫쭮 ⢨:
	   1.蠥 祭 쭮 ६ SP  ᫮ ᢮ ࠬ஢-1
	   2. ஢ 祭 㬥⮢ , ᫨  娥,
	      ᢠ ६ ExecuteError 祭 erInvalidArgument,
	       祬    蠥
	   3.  祭 짮⥫᪮ 㭪樨, , 
		   ࠬ 室  Stack[SP], ன  Stack[SP+1]  .
	   4. ᢠ १ ᫥ Stack[SP]}
        PLongInt = ^LongInt;
var     SP:1..MaxStackDepth;
	Stack:Array[1..MaxStackDepth] of Real;
	{ ⥪ .  뭥ᥭ  䥩, ⠪   
	 楤, 騥 짮⥫᪨ 㭪樨}

	GetVariable:Function(Code:LongInt):Real;
	{ 頥 㪠⥫  짮⥫ 㭪, 
	 祭 㪠 ६.  㬮砭 - 頥 0}
	CheckVariable:Function(VarName:String):LongInt;
	{ 頥 㪠⥫  짮⥫ 㭪, 
	 0 ᫨ ப VarName   ४  ६,
	     ᫥ ।  GetVariable 
	 祭 祭 ⮩ ६}
	ShowError:Procedure(Message:ErrorMessageType;Symbol:String;Position:Integer);
	{ 楤 뢠  砥  訡  樨
	  㬮砭  뢮  䠩 OUTPUT ᮮ饭  ᪮ 몥
	⨪ ࠬ஢:
	   Message - ⨯ 訡
	   Symbol - ᨬ ( . 䨪)  ஬ ᯮ⪭㫠 
           Position -    ப.}
	CompileError:Boolean;{⠭  True, ᫨  樨
        	뫨 訡.  -  ⮬ 뫮 ᮮ饭 楤 ShowError}
        ExecuteError:ErrorMessageType;{ন erNoError,᫨  OK
                                    -  訡 ६ 믮}

	Function CompileExpression(Expr:String):String;
	{ ࠦ  ⭥ 䨪 ଠ}

	Function InterpreteExpression(Code:String):Real;
	{  ࠦ  ७ ଠ  頥  祭}

	Procedure AddStdFunctions;{頥 ⠡ 㭪権 
                                   㤠 ⠭ 㭪樨 (. )}

	Procedure ClearVars;{O頥 ⠡ ६}

	Procedure AddFunction(Name:String;ParamCount:Integer;
			  Code:TCalcFunc);
         {  ⠡ 㭪権 㭪 짮⥫   Name
         (   孥 ॣ), ⢮ ࠬ ParamCount,
          塞 楤ன Code (. ᠭ ⨯ TCalcFunc)}

	Procedure AddVariable(Name:String;Code:Integer);
        {  ⠡ ६ ६   Name( 
          孥 ॣ)   Code. Code  ,  㤥 ।
          㭪 GetVariable,   ࠦ  ६
           . ᫨  訫 ᯮ짮  堭,
           ॠ樨 㭪樨 GetVariable, ᪮ 
          㬮砭    ந}

{⠭ 㭪樨}
Procedure CalcLn;{Ln(X)- ࠫ }
Procedure CalcLg;{Lg(X)-  }
Procedure CalcExp;{exp(X) - e  ⥯ x}
Procedure CalcPwr10;{pwr10(X) - 10  ⥯ x}
Procedure CalcAbs;{Abs(X) - ᮫⭠ 稭 x}
Procedure CalcSqr;{Sqr(X) -  x}
Procedure CalcSqrt;{Sqrt(X) - ७  x}
Procedure CalcSin;{sin(X)}
Procedure CalcCos;{cos(X)}
Procedure CalcTg;{tg(X)}
Procedure CalcArcTg;{arctg(X)}
Procedure CalcArcSin;{arcsin(X)}
Procedure CalcArcCos;{arccos(X)}
Procedure CalcPower;{Power(X,Y) - x  ⥯ y}
Procedure CalcRoot;{Root(X,Y) - ७ ⥯ y  x}
Procedure CalcLog;{Log(X,Y) -  x  ᭮ y}

implementation
Const { 樨}
	  opConst = 0;{騥 6  - ⠭,  ᫥   ⥪}
	  opVariable   = 1;{騥 4  -  ६}
	  opFunction  =2;{᫥騥 4  - 㪠⥫  楤, 
					  ᫥ 맢  ᫥ 㭪樨}
	  opPlus = ord('+');
	  opMinus = ord ('-');
	  opMult = ord ('*');
	  opRDiv = ord ('/');
	  {!  ⮣ ⮡ ஢ 騩 ᯮ塞  
	   ᮯ  ᥣ   祭 ⠭  ᯮ짮
	   Double  Real}
	  Ln10 = 2.302585092994;

var
{$IFDEF OldVersion}
        FuncTable:Array[1..MaxFuncCount] of TFunction;
	VarTable:Array[1..MaxVarCount] of TVariable;
	VarCount:0..MaxVarCount;
	FuncCount:0..MaxFuncCount;
{$ELSE}
   FuncTable, VarTable : PSortedCollection;
Type    PCompTable = ^TCompTable;
        TCompTable = object (TStringCollection)
                       ElSize:Integer;
                       Constructor Init(Alimit,ADelta,AElSize:Integer);
                       Procedure FreeItem(Item:Pointer);virtual;
                     end;
Constructor TCompTable.Init(Alimit,ADelta,AElSize:Integer);
begin
 TStringCollection.Init(Alimit,ADelta);
 ElSize:=AElSize;
end;
Procedure TCompTable.FreeItem(Item:Pointer);
begin
 If Item<>nil then FreeMem(Item,ElSize);
end;
{$ENDIF}


{$F+}
Procedure StdError(Message:ErrorMessageType;Symbol:String;ErrorPoint:Integer);
{$F-}
begin

 Writeln;
 Writeln('^':ErrorPoint);
 Case Message of
 erInvalidSymbol:Writeln('⨬ ᨬ:''',Symbol,'''');
 erUndeclaredVar:Writeln('⭠ ६:',Symbol);
 erUndeclaredFunc:Writeln('⭠ 㭪:',Symbol);
 erExpectedSymbol:Writeln(' ᨬ:',Symbol);
 erExtraCharacters:Writeln('譨 ᨬ  ப');
 erInvalidNumber:Writeln('ࠢ쭮 ᫮');
 end;
end;
{$F+}
Function StdGetVariable(Code:LongInt):Real;
begin
 StdGetVariable:=0;
end;
{$IFDEF OldVersion}
Function StdCheckVariable(VarName:String):LongInt;
var I:Integer;
begin
   i:=1;
   While (I<=VarCount) and (Lexema<>VarTable[i].Name) do
	inc(i);
   isDeclared:=i<=VarCount;
   if i<=VarCount then StdCheckVariable:=VarTable[i].Code else
    StdCheckVariable:=0;
end;
   {$ELSE}
Function StdCheckVariable(VarName:String):LongInt;
var I:Integer;
begin
   if VarTable^.Search(@VarName,i) then
    StdCheckVariable:=PVariable(VarTable^.At(i))^.Code
   else StdCheckVariable:=0;
end;
  {$ENDIF}
{$F-}
Function CompileExpression(Expr:String):String;
Type TLexema=String;
var Lexema:TLexema;{ ᥬ}
	IsNumber,isIdentifier,isFunction:Boolean;{ ᥬ}
	Parameters:Integer;
	ParsePtr:Integer;
	Code:String;
Const ConstValue:String[1+SizeOf(REal)]=chr(opConst)+'      ';
Procedure Error(Message:ErrorMessageType;Symbol:String);
begin
 CompileError:=True;
 ShowError(Message,Symbol,ParsePtr);
end;
  Function IsDeclared(Lexema:TLexema;var Code:String):Boolean;
  var i:LongInt;
  begin
   i:=CheckVariable(Lexema);
   if i<>0 then
    begin
     IsDeclared:=True;
     Code[0]:=#5;
     Code[1]:=chr(OpVariable);
     Move(i,Code[2],SizeOf(LongInt))
    end else IsDeclared:=False;
  end;
Procedure GetLexema;
var i:Integer;
	R:Real;
begin
  isFunction:=False;
  if CompileError then exit;
  if ParsePtr>Length(expr) then begin Lexema:=#13;Exit end;
  Lexema:=Expr[ParsePtr];
  Case Lexema[1] of
  '0'..'9':
			begin
				 i:=1;
			 Repeat
			  inc(i);
			   Lexema[i]:=Expr[ParsePtr+Pred(i)]
			 Until not (Lexema[i] in ['0'..'9','.']);
			 Inc(ParsePtr,Pred(i));
			 Lexema[0]:=Chr(Pred(i));
			 Val(Lexema,R,i);
			 if I<>0 then Error(erInvalidNumber,Lexema);
			 Move(R,ConstValue[2],SizeOf(Real));
			 isNumber:=True;
			 isIdentifier:=False;
			end;
   'A'..'Z','a'..'z':
			begin
			 i:=1;
			 Repeat
			  Lexema[i]:=Upcase(Lexema[i]);
			  inc(i);
			  Lexema[i]:=Expr[ParsePtr+Pred(i)];
			 Until not(Lexema[i] in ['A'..'Z','a'..'z','0'..'9','_']);
			 Lexema[0]:=Pred(chr(i));
			 Inc(ParsePtr,Pred(i));
			 if (ParsePtr<=Length(Expr))and(Expr[ParsePtr]='(') then
			 isFunction:=True;
			 isNumber:=False;
			 isIdentifier:=True;
			end;
   #13,#10,'+','-','*','/','(',')','[',']',',':
			begin
			 isNumber:=False;
			 isIdentifier:=False;
			 inc(ParsePtr);
			end;
   else
			Error(erInvalidSymbol,Lexema);
   end;
  While (ParsePtr<=Length(Expr))and(Expr[ParsePtr] in [' ',#9]) do
   inc(ParsePtr);
end;
Procedure GenerateCode(CodePart:String);
begin
 Code:=Code+CodePart;

end;
Procedure Expression;
var Op:TLexema;
	Procedure Funct;
	var i,j:Integer;
		MyCode:String[5];
             Params:Integer;
	begin
       {$IFDEF OldVersion}
	 i:=1;
	 While (i<=FuncCount) and(Lexema<>FuncTable[i].Name) do
	  inc(i);
	 if i<=FuncCount then
       {$ELSE}
        if FuncTable^.Search(@Lexema,i) then
       {$ENDIF}
	  begin
	   MyCode[0]:=#5;
	   MyCode[1]:=chr(opFunction);
         {$IFDEF OldVersion}
           With FuncTable[i] do
         {$Else}
           With PFunction(FuncTable^.At(i))^ do
          {$ENDIF}
            Begin
             Move(Code,MyCode[2],SizeOf(Pointer));
             Params:=ParamCount;
            end;
	   GetLexema;
	   if Lexema<>'(' then begin Error(erExpectedSymbol,'(');exit end;
	   GetLexema;
	   Expression;
	   j:=2;
	   While j<=Params do
		begin
		 if Lexema<>',' then begin Error(erExpectedSymbol,','); exit end;
		 GetLexema;
		 Expression;
		 inc(j);
		end;
		if Lexema<>')' then begin Error(erExpectedSymbol,')');exit end;
	   GenerateCode(MyCodE);
	  end Else Error(erUndeclaredFunc,Lexema);

	end;
	Procedure Term;
	var Op:TLexema;
      Procedure Factor;
	  var FuncCode:String;
	   begin
		if CompileError then Exit;
		if Lexema='(' then
		 begin{ࠦ  ᪮}
		  GetLexema;
		  Expression;
		  if Lexema<>')' then
		   Error(ErExpectedSymbol,')');
		 end
		else
		   if IsIdentifier then
			if IsFunction then
			 Funct
			else
			 begin
			  if isDeclared(Lexema,FuncCode) then
				GenerateCode(FuncCode)
			  else
			   Error(erUndeclaredVar,Lexema);
			 end
		  else
		   GenerateCode(ConstValue);{६  ⠭}
		GetLexema;
	   end;{Factor}
	begin {Term}
	 if CompileError then exit;
	 Factor;
	  While ((Lexema='*')or(Lexema='/'))and not CompileError do
	   begin
		Op:=Lexema;
		GetLexema;
		Factor;
		GenerateCode(Op);
	  end;
   end;{Term}

begin {Expression}
 if CompileError then exit;
 Term;
 While ((Lexema='+') or (Lexema='-'))and not CompileError do
  begin
	Op:=Lexema;
	GetLexema;
	Term;
	generateCode(Op);
  end;
end;{Expression}

begin
  CompileError:=False;
  Code:='';
  Expr:=Expr+' ';
  ParsePtr:=1;
  GetLexema;
  Expression;
  if Lexema<>#13 then Error(erExtraCharacters,'');
  CompileExpression:=Code;
end;
Function InterpreteExpression(Code:String):Real;
Type PReal=^Real;
	 PPointer=^Pointer;
	 PInteger=^Integer;
var IP:Integer;CurCode:Byte;
	WorkFunction:TCalcFunc;
begin
 SP:=1;
 ip:=1;
 While ip<=Length(Code) do
  begin
   CurCode:=Ord(Code[ip]);
   inc(IP);
   case CurCode of
   opConst:begin
			 inc(SP);
			 Stack[SP]:=PReal(@Code[IP])^;
			 inc(IP,SizeOf(Real));
		   end;
  opVariable:begin
			  inc(SP);
			  Stack[SP]:=GetVariable(PLongInt(@Code[IP])^);
			  inc(IP,SizeOf(LongInt));
			 end;
  opFunction:begin
			   @WorkFunction:=PPointer(@Code[ip])^;
			   inc(IP,SizeOf(Pointer));
			   WorkFunction;
                           if ExecuteError<>erNoError then exit;
			  end;
  opPlus:Begin
			Dec(SP);
			Stack[SP]:=Stack[SP]+Stack[SP+1];
		 end;
  opMinus:Begin
			Dec(SP);
			Stack[SP]:=Stack[SP]-Stack[SP+1];
		 end;
  opMult:Begin
			Dec(SP);
			Stack[SP]:=Stack[SP]*Stack[SP+1];
		 end;
  opRDiv:Begin
                        if Stack[SP]=0.0 then begin ExecuteError:=erDivideByZero;exit;end;
			Dec(SP);
			Stack[SP]:=Stack[SP]/Stack[SP+1];
		 end;
  end;
 end;
 InterpreteExpression:=Stack[SP];
end;
Procedure ClearVars;
begin
{$IFDEF OldVersion}
 VarCount:=0;
{$ELSE}
 VarTable^.FreeAll;
{$ENDIF}
end;
Procedure AddFunction(Name:String;ParamCount:Integer;Code:TCalcFunc);
{$IFDEF OldVersion}
begin
 Inc(FuncCount);
 FuncTable[FuncCount].Name:=Name;
 FuncTable[FuncCount].Code:=@Code;
 FuncTable[FuncCount].ParamCount:=ParamCount;
{$ELSE}
var P:^TFunction;
begin
 New(P);
 P^.Name:=Name;
 P^.Code:=@Code;
 P^.ParamCount:=ParamCount;
 FuncTable^.Insert(P);
{$ENDIF}
end;
Procedure AddVariable(Name:String;Code:Integer);
{$IFDEF OldVersion}
begin
 Inc(VarCount);
 VarTable[VarCount].Name:=Name;
 VarTable[VarCount].Code:=Code;
{$ELSE}
var P:^TVariable;
begin
 New(P);
 P^.Name:=Name;
 P^.Code:=Code;
 VarTable^.Insert(P);
{$ENDIF}
end;
Procedure AddStdFunctions;
begin
{$IFDEF OldVersion}
 FuncCount:=0;
{$ELSE}
 FuncTable^.FreeAll;
{$ENDIF}
 AddFunction('LN',1,CalcLn);
 AddFunction('LG',1,CalcLg);
 AddFunction('EXP',1,CalcExp);
 AddFunction('PWR10',1,CalcPwr10);
 AddFunction('ABS',1,CalcAbs);
 AddFunction('SQR',1,CalcSqr);
 AddFunction('SQRT',1,CalcSqrt);
 AddFunction('SIN',1,CalcSin);
 AddFunction('COS',1,CalcCos);
 AddFunction('TG',1,CalcTg);
 AddFunction('ARCTG',1,CalcArcTg);
 AddFunction('ARCSIN',1,CalcArcSin);
 AddFunction('ARCCOS',1,CalcArcCos);
 AddFunction('POWER',2,CalcPower);
 AddFunction('ROOT',2,CalcRoot);
 AddFunction('LOG',2,CalcLog);
end;
{$F+}
Procedure CalcLn;
begin
 if Stack[SP]<=0 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[Sp]:=Ln(Stack[Sp]);
end;
Procedure CalcLg;
begin
 if Stack[SP]<=0 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[SP]:=Ln(Stack[SP])/Ln10;
end;
Procedure CalcExp;
begin
 Stack[SP]:=Exp(Stack[SP]);
end;
Procedure CalcPwr10;
begin
 Stack[SP]:=Exp(Stack[SP]*Ln10);
end;
Procedure CalcAbs;
begin
 Stack[SP]:=Abs(Stack[SP]);
end;
Procedure CalcSqr;
begin
 Stack[SP]:=Sqr(Stack[SP]);
end;
Procedure CalcSqrt;
begin
 if Stack[SP]<0 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[SP]:=Sqrt(Stack[SP]);
end;
Procedure CalcSin;
begin
 Stack[SP]:=Sin(Stack[SP]);
end;
Procedure CalcCos;
begin
 Stack[SP]:=Cos(Stack[SP]);
end;
Procedure CalcTg;
var R:Real;
begin
 R:=Cos(Stack[SP]);
 if R=0 then Begin ExecuteError:=erInvalidArgument;exit end;
 Stack[Sp]:=Sin(Stack[SP])/R;
end;
Procedure CalcArcTg;
begin
 Stack[SP]:=ArcTan(Stack[SP]);
end;
Procedure CalcArcSin;
begin
 Stack[SP]:=ArcTan(Stack[SP]/Sqrt(1-Sqr(Stack[SP])));
end;
Procedure CalcArcCos;
begin
 if Abs(Stack[SP])>1 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[SP]:=arctan(Sqrt(1-Sqr(Stack[SP]))/Stack[SP]);
end;

{Two-argument functions}
Procedure CalcPower;
begin
 Dec(SP);
 if Stack[SP]<=0 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[SP]:=Exp(Ln(Stack[SP])*Stack[SP+1]);
end;
Procedure CalcRoot;
begin
 Dec(SP);
 Stack[SP]:=Exp(Ln(Stack[SP])/Stack[SP+1]);
end;
Procedure CalcLog;
begin
 if Stack[SP]<=0 then begin ExecuteError:=erInvalidArgument;exit end;
 Dec(SP);
 if Stack[SP]<=0 then begin ExecuteError:=erInvalidArgument;exit end;
 Stack[SP]:=Ln(Stack[SP])/Ln(Stack[SP+1]);
end;
{$F-}
begin
{$IFNDEF OldVersion}
  VarTable:=New(PCompTable,Init(4,4,SizeOf(TVariable)));
  FuncTable:=New(PCompTable,Init(16,4,SizeOf(TFunction)));
{$ELSE}
 ClearVars;
{$ENDIF}
 AddStdFunctions;
 GetVariable:=StdGetVariable	;
 CheckVariable:=StdCheckVariable;
 ShowError:=StdError;
end.

